<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: /builds/eclipse/oniro-core/eddie/common/include/eddie.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_bdd9a5d540de89e9fe90efdfc6973a4f.html">common</a></li><li class="navelem"><a class="el" href="dir_11fbc4217d50ab21044e5ad6614aede5.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">eddie.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2022 Huawei Inc.</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-License-Identifier: Apache-2.0</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#ifndef __EDDIE_H__</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#define __EDDIE_H__</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;cstdint&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="structLink.html">   16</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structLink.html">Link</a> {</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    std::string host;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    std::string port;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    std::string path;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    std::map&lt;std::string, std::string&gt; attrs;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;};</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;std::vector&lt;Link&gt; parse_link_format(std::string link_format);</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> {GET, POST, PUT, DELETE} method_t;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> {</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    CREATED = 65,</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    DELETED = 66,</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    VALID = 67,</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    CHANGED = 68,</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    CONTENT = 69,</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    CONTINUE = 95,</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    BAD_REQUEST = 128,</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    UNAUTHORIZED = 129,</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    BAD_OPTION = 130,</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    FORBIDDEN = 131,</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    NOT_FOUND = 132,</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    METHOD_NOT_ALLOWED = 133,</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    NOT_ACCEPTABLE = 134,</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    REQUEST_ENTITY_INCOMPLETE = 136,</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    CONFLICT = 137,</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    PRECONDITION_FAILED = 140,</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    REQUEST_ENTITY_TOO_LARGE = 141,</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    UNSUPPORTED_CONTENT_FORMAT = 143,</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    UNPROCESSABLE_ENTITY = 150,</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    INTERNAL_SERVER_ERROR = 160,</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    NOT_IMPLEMENTED = 161,</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    BAD_GATEWAY = 162,</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    SERVICE_UNAVAILABLE = 163,</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    GATEWAY_TIMEOUT = 164,</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    PROXYING_NOT_SUPPORTED = 165,</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;} response_code_t;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="structrequest__t.html">   62</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span>{</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keywordtype">char</span> <span class="keyword">const</span> * dst_host;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span> * dst_port;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    method_t method = GET;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span> * path = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span> * query = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">const</span> uint8_t * data = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">size_t</span> data_length = 0;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordtype">bool</span> confirmable = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> content_format = 0;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;} <a class="code" href="structrequest__t.html">request_t</a>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="structmessage__t.html">   74</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span>{</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    std::string data;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    response_code_t status_code;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    std::string src_host;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    std::string src_port;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    std::string location_path;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;} <a class="code" href="structmessage__t.html">message_t</a>;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno"><a class="line" href="classEddieResource.html">   82</a></span>&#160;<span class="keyword">class </span><a class="code" href="classEddieResource.html">EddieResource</a> {</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div>
<div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classEddieResource.html#ab0d354d94f9e1ce71597b8e842850441">   90</a></span>&#160;    <span class="keyword">virtual</span> <a class="code" href="structmessage__t.html">message_t</a> <a class="code" href="classEddieResource.html#ab0d354d94f9e1ce71597b8e842850441">render_get</a>(<a class="code" href="structrequest__t.html">request_t</a> &amp;request) {</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <a class="code" href="structmessage__t.html">message_t</a> response;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        response.status_code = NOT_IMPLEMENTED;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keywordflow">return</span> response;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    }</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="classEddieResource.html#ad14a722575480386f40592d281c70d43">  101</a></span>&#160;    <span class="keyword">virtual</span> <a class="code" href="structmessage__t.html">message_t</a> <a class="code" href="classEddieResource.html#ad14a722575480386f40592d281c70d43">render_post</a>(<a class="code" href="structrequest__t.html">request_t</a> &amp;request) {</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <a class="code" href="structmessage__t.html">message_t</a> response;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        response.status_code = NOT_IMPLEMENTED;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keywordflow">return</span> response;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    }</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160; </div>
<div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="classEddieResource.html#a78e82350f95b96a67f53525f687ecf33">  112</a></span>&#160;    <span class="keyword">virtual</span> <a class="code" href="structmessage__t.html">message_t</a> <a class="code" href="classEddieResource.html#a78e82350f95b96a67f53525f687ecf33">render_put</a>(<a class="code" href="structrequest__t.html">request_t</a> &amp;request) {</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <a class="code" href="structmessage__t.html">message_t</a> response;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        response.status_code = NOT_IMPLEMENTED;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keywordflow">return</span> response;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    }</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160; </div>
<div class="line"><a name="l00123"></a><span class="lineno"><a class="line" href="classEddieResource.html#a02255eac7ca0bf2772e3fe8456f2b9f3">  123</a></span>&#160;    <span class="keyword">virtual</span> <a class="code" href="structmessage__t.html">message_t</a> <a class="code" href="classEddieResource.html#a02255eac7ca0bf2772e3fe8456f2b9f3">render_delete</a>(<a class="code" href="structrequest__t.html">request_t</a> &amp;request) {</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <a class="code" href="structmessage__t.html">message_t</a> response;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        response.status_code = NOT_IMPLEMENTED;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        <span class="keywordflow">return</span> response;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    }</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160; </div>
<div class="line"><a name="l00134"></a><span class="lineno"><a class="line" href="classEddieResource.html#a7d22791c7affe5f78618ef7b7a3210e1">  134</a></span>&#160;    <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span> * <span class="keyword">const</span> * <a class="code" href="classEddieResource.html#a7d22791c7affe5f78618ef7b7a3210e1">get_path</a>() {</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    }</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160; </div>
<div class="line"><a name="l00143"></a><span class="lineno"><a class="line" href="classEddieResource.html#ab36287546947cd2c17568edc03b5b271">  143</a></span>&#160;    <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span> * <span class="keyword">const</span> * <a class="code" href="classEddieResource.html#ab36287546947cd2c17568edc03b5b271">get_attributes</a>() {</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    }</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <a class="code" href="structmessage__t.html">message_t</a> request_handler(<a class="code" href="structrequest__t.html">request_t</a> &amp;request) {</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keywordflow">switch</span> (request.method) {</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <span class="keywordflow">case</span> GET:</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;            <span class="keywordflow">return</span> <a class="code" href="classEddieResource.html#ab0d354d94f9e1ce71597b8e842850441">render_get</a>(request);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="keywordflow">case</span> POST:</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            <span class="keywordflow">return</span> <a class="code" href="classEddieResource.html#ad14a722575480386f40592d281c70d43">render_post</a>(request);</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keywordflow">case</span> PUT:</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            <span class="keywordflow">return</span> <a class="code" href="classEddieResource.html#a78e82350f95b96a67f53525f687ecf33">render_put</a>(request);</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordflow">case</span> DELETE:</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            <span class="keywordflow">return</span> <a class="code" href="classEddieResource.html#a02255eac7ca0bf2772e3fe8456f2b9f3">render_delete</a>(request);</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        }</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <a class="code" href="structmessage__t.html">message_t</a> response;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        response.status_code = METHOD_NOT_ALLOWED;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keywordflow">return</span> response;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    }</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160; </div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    std::string get_path_str() {</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">char</span> * <span class="keyword">const</span> * path = <a class="code" href="classEddieResource.html#a7d22791c7affe5f78618ef7b7a3210e1">get_path</a>();</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        std::string res;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160; </div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <span class="keywordflow">if</span> (path[0] == <span class="keyword">nullptr</span>) <span class="keywordflow">return</span> <span class="stringliteral">&quot;&quot;</span>;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="keywordflow">else</span> res = path[0];</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160; </div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1; path[i]; i++)</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            res += <span class="stringliteral">&quot;/&quot;</span> + std::string(path[i]);</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160; </div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keywordflow">return</span> res;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    }</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160; </div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    std::vector&lt;std::string&gt; get_attributes_str() {</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">char</span> * <span class="keyword">const</span> * attributes = <a class="code" href="classEddieResource.html#ab36287546947cd2c17568edc03b5b271">get_attributes</a>();</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        std::vector&lt;std::string&gt; res;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; attributes[i]; i++) {</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;            res.emplace_back(attributes[i]);</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        }</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        <span class="keywordflow">return</span> res;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    }</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;};</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160; </div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="aclassEddieResource_html"><div class="ttname"><a href="classEddieResource.html">EddieResource</a></div><div class="ttdef"><b>Definition:</b> eddie.h:82</div></div>
<div class="ttc" id="aclassEddieResource_html_a02255eac7ca0bf2772e3fe8456f2b9f3"><div class="ttname"><a href="classEddieResource.html#a02255eac7ca0bf2772e3fe8456f2b9f3">EddieResource::render_delete</a></div><div class="ttdeci">virtual message_t render_delete(request_t &amp;request)</div><div class="ttdef"><b>Definition:</b> eddie.h:123</div></div>
<div class="ttc" id="aclassEddieResource_html_a78e82350f95b96a67f53525f687ecf33"><div class="ttname"><a href="classEddieResource.html#a78e82350f95b96a67f53525f687ecf33">EddieResource::render_put</a></div><div class="ttdeci">virtual message_t render_put(request_t &amp;request)</div><div class="ttdef"><b>Definition:</b> eddie.h:112</div></div>
<div class="ttc" id="aclassEddieResource_html_a7d22791c7affe5f78618ef7b7a3210e1"><div class="ttname"><a href="classEddieResource.html#a7d22791c7affe5f78618ef7b7a3210e1">EddieResource::get_path</a></div><div class="ttdeci">virtual const char *const  * get_path()</div><div class="ttdef"><b>Definition:</b> eddie.h:134</div></div>
<div class="ttc" id="aclassEddieResource_html_ab0d354d94f9e1ce71597b8e842850441"><div class="ttname"><a href="classEddieResource.html#ab0d354d94f9e1ce71597b8e842850441">EddieResource::render_get</a></div><div class="ttdeci">virtual message_t render_get(request_t &amp;request)</div><div class="ttdef"><b>Definition:</b> eddie.h:90</div></div>
<div class="ttc" id="aclassEddieResource_html_ab36287546947cd2c17568edc03b5b271"><div class="ttname"><a href="classEddieResource.html#ab36287546947cd2c17568edc03b5b271">EddieResource::get_attributes</a></div><div class="ttdeci">virtual const char *const  * get_attributes()</div><div class="ttdef"><b>Definition:</b> eddie.h:143</div></div>
<div class="ttc" id="aclassEddieResource_html_ad14a722575480386f40592d281c70d43"><div class="ttname"><a href="classEddieResource.html#ad14a722575480386f40592d281c70d43">EddieResource::render_post</a></div><div class="ttdeci">virtual message_t render_post(request_t &amp;request)</div><div class="ttdef"><b>Definition:</b> eddie.h:101</div></div>
<div class="ttc" id="astructLink_html"><div class="ttname"><a href="structLink.html">Link</a></div><div class="ttdef"><b>Definition:</b> eddie.h:16</div></div>
<div class="ttc" id="astructmessage__t_html"><div class="ttname"><a href="structmessage__t.html">message_t</a></div><div class="ttdef"><b>Definition:</b> eddie.h:74</div></div>
<div class="ttc" id="astructrequest__t_html"><div class="ttname"><a href="structrequest__t.html">request_t</a></div><div class="ttdef"><b>Definition:</b> eddie.h:62</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
